﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="ControlDemo.aspx.cs" Inherits="ControlDemo" 
         enableviewstate="false" Trace="false"%>

<%@ Register Src="ShowCode.ascx" TagName="ShowCode" TagPrefix="uc1" %>
<%@ Register Assembly="Westwind.Web.Controls.PreservePropertyControl" 
             Namespace="Westwind.Web.Controls" TagPrefix="ww" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>PreservePropertyControl Test Page</title>
    <link href="westwind.css" rel="stylesheet" type="text/css" />
    <link href="/csharp.css" rel="stylesheet" type="text/css" />
</head>
<body>
    <form id="form1" runat="server">
    <div>
        <h1>PreservePropertyControl Test Page</h1>
        <br />
        &nbsp;<a href="ControlDemo.aspx">Reset Page</a>
        <p />
        Enter a color: <asp:TextBox ID="txtColor" runat="server">Green</asp:TextBox>&nbsp;
        <asp:Button ID="btnSubmit" runat = "server" OnClick="Button1_Click" Text="Show" />
        <asp:Button ID="btnSubmit2" runat="server"  Text="Post Back" />
        <hr />
        <asp:Label ID="lblMessage" runat="server" />&nbsp;<br />
        <br />
        
        <asp:Panel ID="Panel1" runat="server" Height="68px" Width="323px" BorderWidth="1" BorderColor="black">
            <br />
            &nbsp;&nbsp;
            <asp:Label ID="lblMessage2" runat="server" Height="26px" Width="96px" text="New Text"/></asp:Panel>
       
       
       <br />

     
<ww:PreservePropertyControl ID="Persister" runat="server" StorageMode="HiddenVariable">
    <PreservedProperties>
         <ww:PreservedProperty ID="PreservedProperty1" runat="server"  
                               ControlId="btnSubmit"   
                               Property="ForeColor"></ww:PreservedProperty>
        <ww:PreservedProperty ID="PreservedProperty2" runat="server" 
                              ControlId="lblMessage2" 
                              Property="BackColor"></ww:PreservedProperty>
    </PreservedProperties>
</ww:PreservePropertyControl>       

    
    <hr />
    This form demonstrates persisting specific values automatically without using ViewState.
    On this form there's PreservePropertyControl and it's persisting a handful of properties
    and automatically reassigning their value as ViewState would without ViewState's full overhead. On this page the Show Button's and the Message ForeColor, an Address
    business object and the backcolor of the label text in the panel are all persisted
    using the PresevePropertyControl.<p></p>
    You can also persist things properties of the form or controls directly. For example,
        here an address business object is persisted and automatically restored on the next hit. It's even more useful with more simple values like PKs of the record(s) you're
        editing without having to resort to ViewState values.<br />
    <br />
    Same rules as ViewState apply: You can only persist simple values or ISerializable
    objects so not everything can be persisted. For example, things like FontInfo and
    StyleCollections don't persist.
    <br />
    <hr />
    <uc1:ShowCode id="ShowCode1" runat="server" CodeFile="ControlDemo.aspx" Text="Show ASPX" >
    </uc1:ShowCode>
    <uc1:ShowCode id="ShowCode2" runat="server" CodeFile="ControlDemo.aspx.cs" Text="Show C#" >
    </uc1:ShowCode>
    
    </div>
    </form>
</body>
</html>
